﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Reflection;
using System.Text;

namespace ReadConfigValues {
    class Program {
        public static int iMax = 0;
        public static string sText = "JJR";

        static void Main(string[] args) {
            ReadConfigValuesNormal();
            Console.WriteLine("Read Normal");
            Console.WriteLine("iMax - " + iMax);
            Console.WriteLine("sText - " + sText);
            iMax = 0;
            sText = "JJR";
            Console.WriteLine("Reset");
            Console.WriteLine("iMax - " + iMax);
            Console.WriteLine("sText - " + sText);
            Console.WriteLine("Read Reflection");
            ReadConfigValuesReflection();
            Console.WriteLine("iMax - " + iMax);
            Console.WriteLine("sText - " + sText);
            Console.WriteLine("Read Reflection Fullname");
            ReadConfigValuesReflectionFullname();
            Console.WriteLine("iMax - " + iMax);
            Console.WriteLine("sText - " + sText);
            Console.ReadLine();    
        }

        static void ReadConfigValuesNormal() {
            string s = null;
            s = ConfigurationManager.AppSettings["iMax"];
            iMax = (s != null) ? Convert.ToInt32(s) : iMax;
            s = ConfigurationManager.AppSettings["sText"];
            sText = s ?? sText;       
        }

        static void ReadConfigValuesReflection() {
            FieldInfo[] fi = MethodInfo.GetCurrentMethod().ReflectedType.GetFields();                
            foreach (FieldInfo info in fi) {
                string s = ConfigurationManager.AppSettings[info.Name];
                if (s!=null) {
                    switch(info.FieldType.ToString()) {
                    case "System.String" : 
                                info.SetValue(null,s);
                            break;
                    case "System.Int32" : 
                                info.SetValue(null,Convert.ToInt32(s));
                            break;
                    }
                }
            }            
        }

        static void ReadConfigValuesReflectionFullname() {
            Type t = MethodInfo.GetCurrentMethod().ReflectedType;
            FieldInfo[] fi = t.GetFields();               
            foreach (FieldInfo info in fi) {                
                string s = ConfigurationManager.AppSettings[t.FullName+"."+info.Name];
                if (s!=null) {
                    switch(info.FieldType.ToString()) {
                    case "System.String" : 
                                info.SetValue(null,s);
                            break;
                    case "System.Int32" : 
                                info.SetValue(null,Convert.ToInt32(s));
                            break;
                    }
                }
            }            
        }
    }
}
